<template>
  <rui-toolbar>
    <template v-if="$slots.default || persistent">
      <!-- @slot Persistent buttons -->
      <slot>
        <template v-for="(item, index) in persistent" :key="index">
          <rui-toolbar-separator v-if="item === 'separator'" />
          <rui-button v-else v-bind="propsForItem(item)" @click="item.onclick" />
        </template>
      </slot>
    </template>

    <template v-if="$slots.help" #right>
      <rui-help-button>
        <!-- @slot Help content -->
        <slot name="help" />
      </rui-help-button>
    </template>

    <template v-for="(item, index) in groupedItems.visible" :key="index">
      <rui-toolbar-separator v-if="item === 'separator'" />
      <rui-button v-else v-bind="propsForItem(item)" @click="item.onclick" />
    </template>

    <template v-if="groupedItems.hidden.length > 0">
      <rui-toolbar-separator />
      <rui-dropdown :right="right" no-caption>
        <template v-for="(item, index) in groupedItems.hidden" :key="index">
          <rui-menu-item-separator v-if="item === 'separator'" />
          <rui-menu-item v-else v-bind="propsForItem(item, true)" @click="item.onclick" />
        </template>
      </rui-dropdown>
    </template>
  </rui-toolbar>
</template>

<script>
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiDropdown from '@experiments-labs/rise_ui/src/components/Dropdown/Dropdown.vue'
import RuiHelpButton from '@experiments-labs/rise_ui/src/components/HelpButton/HelpButton.vue'
import RuiMenuItem from '@experiments-labs/rise_ui/src/components/Menu/MenuItem.vue'
import RuiMenuItemSeparator from '@experiments-labs/rise_ui/src/components/Menu/MenuItemSeparator.vue'
import RuiToolbar from '@experiments-labs/rise_ui/src/components/Toolbar/Toolbar.vue'
import RuiToolbarSeparator from '@experiments-labs/rise_ui/src/components/Toolbar/ToolbarSeparator.vue'

import { handledBreakpoints } from '../../plugins/Breakpoints'

/**
 * @typedef {{icon: ?string, variant: ?string, caption: string, to: ?string | ?object, onclick: ?Function}} ToolbarEntry
 */

/**
 * Displays a toolbar which collapses on a given breakpoint and smaller
 *
 * The list props takes a list of entries/separators; entries can have the following properties:
 * - `caption`     - used as button title (hover) or entry caption in dropdown
 * - `showCaption` - Whether to display the caption on non-collapsed button
 * - `icon`        - optional button icon
 * - `variant`     - optional button variant
 * - `onclick`     - optional click handler
 * - `to`          - optional Vue router route
 *
 * Example list:
 * ```js
 * const entries = [
 * {caption: 'Home', icon: 'home', to: '/'},
 * 'separator',
 * // other entries and separators...
 * ]
 * ```
 *
 * @noPlayground
 */
export default {
  name: 'GpCollapsibleToolbar',
  components: { RuiHelpButton, RuiMenuItem, RuiMenuItemSeparator, RuiDropdown, RuiButton, RuiToolbarSeparator, RuiToolbar },
  props: {
    /** List of items to display or hide depending on the screen size */
    items: { required: true, type: Array, default: () => [] },
    /** List of items that are always visible. Overridden by the `default` slot */
    persistent: { required: false, type: Array, default: () => [] },
    /** List of items that are always hidden */
    hidden: { required: false, type: Array, default: () => [] },
    /** Whether to align the dropdown menu on the right of the button */
    right: { required: false, type: Boolean, default: false },
    /** Breakpoint name at which the toolbar collapses */
    breakpoint: { required: false, type: String, default: 'small', validator: (v) => handledBreakpoints.includes(v) },
  },
  computed: {
    groupedItems () {
      const list = { visible: [], hidden: [] }
      if (this.hide) {
        list.hidden = [...this.items, ...this.hidden]
      } else {
        list.visible = [...this.items]
        list.hidden = [...this.hidden]
      }

      // Remove extra separators
      if (list.visible.length > 0 && list.visible[list.visible.length - 1] === 'separator') list.visible.pop()
      if (list.visible.length > 0 && list.visible[0] === 'separator' && (!this.$slots.default && this.persistent.length === 0)) list.visible.shift()
      if (list.hidden.length > 0 && list.hidden[0] === 'separator') list.hidden.shift()

      return list
    },
    hide () { return this.$smallerThan(this.breakpoint) },
  },
  methods: {
    /**
     * Determines props to add to a button for the given item
     *
     * @param   {ToolbarEntry} item     - Item
     * @param   {boolean}      dropdown - Whether this item is in a dropdown
     *
     * @returns {object}                Component props
     */
    propsForItem (item, dropdown = false) {
      const props = {}
      props[dropdown || item.showCaption ? 'caption' : 'title'] = item.caption

      if (item.icon) props.icon = item.icon
      if (item.variant) props.variant = item.variant
      if (item.to) props.to = item.to
      if (item.disabled) props.disabled = item.disabled

      return props
    },
  },
}
</script>
